odoo.define('kyb_sgt_website_ruc', function(require) {
    'use strict';
    require('website_portal');

	/* FUNCION QUE PERMITE COLOCAR EL FIELD SELECT EN SOLO LECTURA */
    $('.selectReadonly').prop('disabled', true);
	/* FUNCION QUE PERMITE QUE ANTES DE ENVIAR LOS DATOS AL POST DEL FORMULARIO, 
	SE QUITE EL SOLO LECTURA (disabled) DEL FIELD SELECT PARA QUE EL DATO PUEDA SER GUARDADO EN BASE DE DATOS */
    $('.forms_submit').on('submit', function() {
        $('.selectReadonly').prop('disabled', false);
    });

	/* EVENTOS ONCHANGE PARA EL DOMICILIO FISCAL */
    if(!$('.o_website_domicilio').length) {
        return $.Deferred().reject("DOM doesn't contain '.o_website_domicilio'");
    }
    /* Onchange para limpiar los municipios cuando un estado no esté asociado a su id */
    var municipality_options = $("select[name='municipality_id']:enabled option:not(:first)");
    $('.o_website_domicilio').on('change', "select[name='state_id']", function () {
        var select = $("select[name='municipality_id']");
        municipality_options.detach();
        var displayed_municipality = municipality_options.filter("[data-state_id="+($(this).val() || 0)+"]");
        var nb = displayed_municipality.appendTo(select).show().size();
        select.parent().toggle(nb>=1);
    });

    /* Onchange para limpiar las parroquias cuando un municipio no esté asociado a su id */
    var parishes_options = $("select[name='parish_id']:enabled option:not(:first)");
    $('.o_website_domicilio').on('change', "select[name='municipality_id']", function () {
        var select = $("select[name='parish_id']");
        parishes_options.detach();
        var displayed_parish = parishes_options.filter("[data-municipality_id="+($(this).val() || 0)+"]");
        var nb = displayed_parish.appendTo(select).show().size();
        select.parent().toggle(nb>=1);
    });

    /* Onchange para limpiar las parroquias cuando se seleccione un estado distinto */
    var parishes_municipality = $("select[name='parish_id']:enabled option:not(:first)");
    $('.o_website_domicilio').on('change', "select[name='state_id']", function () {
        var select = $("select[name='parish_id']");
        parishes_municipality.detach();
        var displayed_parish_municipality = parishes_municipality.filter("[data-state_id="+($(this).val() || 0)+"]");
        var nb = displayed_parish_municipality.appendTo(select).show().size();
        select.parent().toggle(nb>=1);
    });
	/* FIN DEL EVENTO ONCHANGE */
    
	});
